package cz.jzitnik.game;

import cz.jzitnik.game.sprites.*;
import cz.jzitnik.game.sprites.SimpleSprite;
import cz.jzitnik.tui.Sprite;
import cz.jzitnik.tui.SpriteList;

import java.util.HashMap;

public class SpriteLoader {
    public enum SPRITES {
        AIR,
        DIRT,
        GRASS,
        STEVE,
        STONE,
        BEDROCK,
        BREAKING,
        CRAFTING_TABLE,

        OAK_LOG,
        OAK_LEAF,
        OAK_PLANKS,

        // Items
        ITEM_DIRT,
        ITEM_OAK_LOG,
        ITEM_OAK_PLANKS,
        ITEM_STICK,
        ITEM_CRAFTING_TABLE
    }

    public static final HashMap<SPRITES, Sprite> SPRITES_MAP = new HashMap<>();

    static {
        SPRITES_MAP.put(SPRITES.AIR, new Air());
        SPRITES_MAP.put(SPRITES.DIRT, new Dirt());
        SPRITES_MAP.put(SPRITES.GRASS, new Grass());
        SPRITES_MAP.put(SPRITES.STONE, new Stone());
        SPRITES_MAP.put(SPRITES.STEVE, new Steve());
        SPRITES_MAP.put(SPRITES.BEDROCK, new Bedrock());
        SPRITES_MAP.put(SPRITES.BREAKING, new Breaking());
        SPRITES_MAP.put(SPRITES.OAK_LOG, new OakLog());
        SPRITES_MAP.put(SPRITES.OAK_LEAF, new OakLeaf());
        SPRITES_MAP.put(SPRITES.OAK_PLANKS, new SimpleSprite("oak_planks.ans"));
        SPRITES_MAP.put(SPRITES.CRAFTING_TABLE, new SimpleSprite("crafting_table.ans"));

        SPRITES_MAP.put(SPRITES.ITEM_DIRT, new SimpleSprite("items/dirt.ans"));
        SPRITES_MAP.put(SPRITES.ITEM_OAK_LOG, new SimpleSprite("items/oak_log.ans"));
        SPRITES_MAP.put(SPRITES.ITEM_OAK_PLANKS, new SimpleSprite("items/oak_planks.ans"));
        SPRITES_MAP.put(SPRITES.ITEM_STICK, new SimpleSprite("items/stick.ans"));
        SPRITES_MAP.put(SPRITES.ITEM_CRAFTING_TABLE, new SimpleSprite("items/crafting_table.ans"));
    }

    public static SpriteList<SPRITES> load() {
        return new SpriteList<>(SPRITES.class, SPRITES_MAP);
    }
}
